"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from glean.api_client.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ActivityEventParamsTypedDict(TypedDict):
    body_content: NotRequired[str]
    r"""The HTML content of the page body."""
    datasource_instance: NotRequired[str]
    r"""The full datasource instance name inferred from the URL of the event"""
    datasource: NotRequired[str]
    r"""The datasource without the instance inferred from the URL of the event"""
    instance_only_name: NotRequired[str]
    r"""The instance only name of the datasource instance, e.g. 1 for jira_1, inferred from the URL of the event"""
    duration: NotRequired[int]
    r"""Length in seconds of the activity. For VIEWS, this represents the amount the page was visible in the foreground."""
    query: NotRequired[str]
    r"""The user's search query associated with a SEARCH."""
    referrer: NotRequired[str]
    r"""The referring URL of the VIEW or SEARCH."""
    title: NotRequired[str]
    r"""The page title associated with the URL of the event"""
    truncated: NotRequired[bool]
    r"""Indicates that the parameters are incomplete and more parameters may be sent with the same action+timestamp+URL in the future. This is used for sending the duration when a `VIEW` is finished."""


class ActivityEventParams(BaseModel):
    body_content: Annotated[Optional[str], pydantic.Field(alias="bodyContent")] = None
    r"""The HTML content of the page body."""

    datasource_instance: Annotated[
        Optional[str], pydantic.Field(alias="datasourceInstance")
    ] = None
    r"""The full datasource instance name inferred from the URL of the event"""

    datasource: Optional[str] = None
    r"""The datasource without the instance inferred from the URL of the event"""

    instance_only_name: Annotated[
        Optional[str], pydantic.Field(alias="instanceOnlyName")
    ] = None
    r"""The instance only name of the datasource instance, e.g. 1 for jira_1, inferred from the URL of the event"""

    duration: Optional[int] = None
    r"""Length in seconds of the activity. For VIEWS, this represents the amount the page was visible in the foreground."""

    query: Optional[str] = None
    r"""The user's search query associated with a SEARCH."""

    referrer: Optional[str] = None
    r"""The referring URL of the VIEW or SEARCH."""

    title: Optional[str] = None
    r"""The page title associated with the URL of the event"""

    truncated: Optional[bool] = None
    r"""Indicates that the parameters are incomplete and more parameters may be sent with the same action+timestamp+URL in the future. This is used for sending the duration when a `VIEW` is finished."""
