"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from glean.api_client.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ContentDefinitionTypedDict(TypedDict):
    r"""Describes text content or base64 encoded binary content"""

    mime_type: str
    text_content: NotRequired[str]
    r"""text content. Only one of textContent or binary content can be specified"""
    binary_content: NotRequired[str]
    r"""base64 encoded binary content. Only one of textContent or binary content can be specified"""


class ContentDefinition(BaseModel):
    r"""Describes text content or base64 encoded binary content"""

    mime_type: Annotated[str, pydantic.Field(alias="mimeType")]

    text_content: Annotated[Optional[str], pydantic.Field(alias="textContent")] = None
    r"""text content. Only one of textContent or binary content can be specified"""

    binary_content: Annotated[Optional[str], pydantic.Field(alias="binaryContent")] = (
        None
    )
    r"""base64 encoded binary content. Only one of textContent or binary content can be specified"""
