"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from glean.api_client.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class DocumentStatusResponseTypedDict(TypedDict):
    r"""Describes the document status response body"""

    upload_status: NotRequired[str]
    r"""Upload status, enum of NOT_UPLOADED, UPLOADED, STATUS_UNKNOWN"""
    last_uploaded_at: NotRequired[str]
    r"""Time of last successful upload for the document, in ISO 8601 format"""
    indexing_status: NotRequired[str]
    r"""Indexing status, enum of NOT_INDEXED, INDEXED, STATUS_UNKNOWN"""
    last_indexed_at: NotRequired[str]
    r"""Time of last successful indexing for the document, in ISO 8601 format"""
    permission_identity_status: NotRequired[str]
    r"""Permission identity status, enum of NOT_UPLOADED, UPLOADED, STATUS_UNKNOWN (Always unknown if `identityDatasourceName` is set). Document visibility may be affected status is `NOT_UPLOADED`."""


class DocumentStatusResponse(BaseModel):
    r"""Describes the document status response body"""

    upload_status: Annotated[Optional[str], pydantic.Field(alias="uploadStatus")] = None
    r"""Upload status, enum of NOT_UPLOADED, UPLOADED, STATUS_UNKNOWN"""

    last_uploaded_at: Annotated[
        Optional[str], pydantic.Field(alias="lastUploadedAt")
    ] = None
    r"""Time of last successful upload for the document, in ISO 8601 format"""

    indexing_status: Annotated[
        Optional[str], pydantic.Field(alias="indexingStatus")
    ] = None
    r"""Indexing status, enum of NOT_INDEXED, INDEXED, STATUS_UNKNOWN"""

    last_indexed_at: Annotated[Optional[str], pydantic.Field(alias="lastIndexedAt")] = (
        None
    )
    r"""Time of last successful indexing for the document, in ISO 8601 format"""

    permission_identity_status: Annotated[
        Optional[str], pydantic.Field(alias="permissionIdentityStatus")
    ] = None
    r"""Permission identity status, enum of NOT_UPLOADED, UPLOADED, STATUS_UNKNOWN (Always unknown if `identityDatasourceName` is set). Document visibility may be affected status is `NOT_UPLOADED`."""
