"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from glean.api_client.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class IndexingShortcutTypedDict(TypedDict):
    input_alias: str
    r"""link text following the viewPrefix as entered by the user. For example, if the view prefix is `go/` and the shortened URL is `go/abc`, then `abc` is the inputAlias."""
    destination_url: str
    r"""destination URL for the shortcut."""
    created_by: str
    r"""Email of the user who created this shortcut."""
    description: NotRequired[str]
    r"""A short, plain text blurb to help people understand the intent of the shortcut."""
    create_time: NotRequired[int]
    r"""The time the shortcut was created in epoch seconds."""
    updated_by: NotRequired[str]
    r"""Email of the user who last updated this shortcut."""
    update_time: NotRequired[int]
    r"""The time the shortcut was updated in epoch seconds."""
    unlisted: NotRequired[bool]
    r"""Whether this shortcut is unlisted or not. Unlisted shortcuts are visible to author and admins only."""
    url_template: NotRequired[str]
    r"""For variable shortcuts, contains the URL template; note, `destinationUrl` contains default URL."""


class IndexingShortcut(BaseModel):
    input_alias: Annotated[str, pydantic.Field(alias="inputAlias")]
    r"""link text following the viewPrefix as entered by the user. For example, if the view prefix is `go/` and the shortened URL is `go/abc`, then `abc` is the inputAlias."""

    destination_url: Annotated[str, pydantic.Field(alias="destinationUrl")]
    r"""destination URL for the shortcut."""

    created_by: Annotated[str, pydantic.Field(alias="createdBy")]
    r"""Email of the user who created this shortcut."""

    description: Optional[str] = None
    r"""A short, plain text blurb to help people understand the intent of the shortcut."""

    create_time: Annotated[Optional[int], pydantic.Field(alias="createTime")] = None
    r"""The time the shortcut was created in epoch seconds."""

    updated_by: Annotated[Optional[str], pydantic.Field(alias="updatedBy")] = None
    r"""Email of the user who last updated this shortcut."""

    update_time: Annotated[Optional[int], pydantic.Field(alias="updateTime")] = None
    r"""The time the shortcut was updated in epoch seconds."""

    unlisted: Optional[bool] = None
    r"""Whether this shortcut is unlisted or not. Unlisted shortcuts are visible to author and admins only."""

    url_template: Annotated[Optional[str], pydantic.Field(alias="urlTemplate")] = None
    r"""For variable shortcuts, contains the URL template; note, `destinationUrl` contains default URL."""
