"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .propertydefinition import PropertyDefinition, PropertyDefinitionTypedDict
from .propertygroup import PropertyGroup, PropertyGroupTypedDict
from enum import Enum
from glean.api_client.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class DocCategory(str, Enum):
    r"""The document category of this object type."""

    UNCATEGORIZED = "UNCATEGORIZED"
    TICKETS = "TICKETS"
    CRM = "CRM"
    PUBLISHED_CONTENT = "PUBLISHED_CONTENT"
    COLLABORATIVE_CONTENT = "COLLABORATIVE_CONTENT"
    QUESTION_ANSWER = "QUESTION_ANSWER"
    MESSAGING = "MESSAGING"
    CODE_REPOSITORY = "CODE_REPOSITORY"
    CHANGE_MANAGEMENT = "CHANGE_MANAGEMENT"
    PEOPLE = "PEOPLE"
    EMAIL = "EMAIL"
    SSO = "SSO"
    ATS = "ATS"
    KNOWLEDGE_HUB = "KNOWLEDGE_HUB"
    EXTERNAL_SHORTCUT = "EXTERNAL_SHORTCUT"
    ENTITY = "ENTITY"
    CALENDAR = "CALENDAR"


class ObjectDefinitionTypedDict(TypedDict):
    r"""The definition for an `DocumentMetadata.objectType` within a datasource."""

    name: NotRequired[str]
    r"""Unique identifier for this `DocumentMetadata.objectType`. If omitted, this definition is used as a default for all unmatched `DocumentMetadata.objectType`s in this datasource."""
    display_label: NotRequired[str]
    r"""The user-friendly name of the object for display."""
    doc_category: NotRequired[DocCategory]
    r"""The document category of this object type."""
    property_definitions: NotRequired[List[PropertyDefinitionTypedDict]]
    property_groups: NotRequired[List[PropertyGroupTypedDict]]
    r"""A list of `PropertyGroup`s belonging to this object type, which will group properties to be displayed together in the UI."""
    summarizable: NotRequired[bool]
    r"""Whether or not the object is summarizable"""


class ObjectDefinition(BaseModel):
    r"""The definition for an `DocumentMetadata.objectType` within a datasource."""

    name: Optional[str] = None
    r"""Unique identifier for this `DocumentMetadata.objectType`. If omitted, this definition is used as a default for all unmatched `DocumentMetadata.objectType`s in this datasource."""

    display_label: Annotated[Optional[str], pydantic.Field(alias="displayLabel")] = None
    r"""The user-friendly name of the object for display."""

    doc_category: Annotated[
        Optional[DocCategory], pydantic.Field(alias="docCategory")
    ] = None
    r"""The document category of this object type."""

    property_definitions: Annotated[
        Optional[List[PropertyDefinition]], pydantic.Field(alias="propertyDefinitions")
    ] = None

    property_groups: Annotated[
        Optional[List[PropertyGroup]], pydantic.Field(alias="propertyGroups")
    ] = None
    r"""A list of `PropertyGroup`s belonging to this object type, which will group properties to be displayed together in the UI."""

    summarizable: Optional[bool] = None
    r"""Whether or not the object is summarizable"""
