"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .grantpermission import GrantPermission, GrantPermissionTypedDict
from .readpermission import ReadPermission, ReadPermissionTypedDict
from .writepermission import WritePermission, WritePermissionTypedDict
from glean.api_client.types import BaseModel
import pydantic
from typing import Dict, List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PermissionsTypedDict(TypedDict):
    r"""Describes the permissions levels that a user has for permissioned features. When the client sends this, Permissions.read and Permissions.write are the additional permissions granted to a user on top of what they have via their roles.
    When the server sends this, Permissions.read and Permissions.write are the complete (merged) set of permissions the user has, and Permissions.roles is just for display purposes.
    """

    can_admin_search: NotRequired[bool]
    r"""TODO--deprecate in favor of the read and write properties. True if the user has access to /adminsearch"""
    can_admin_client_api_global_tokens: NotRequired[bool]
    r"""TODO--deprecate in favor of the read and write properties. True if the user can administrate client API tokens with global scope"""
    can_dlp: NotRequired[bool]
    r"""TODO--deprecate in favor of the read and write properties. True if the user has access to data loss prevention (DLP) features"""
    read: NotRequired[Dict[str, List[ReadPermissionTypedDict]]]
    r"""Describes the read permission levels that a user has for permissioned features. Key must be PermissionedFeatureOrObject"""
    write: NotRequired[Dict[str, List[WritePermissionTypedDict]]]
    r"""Describes the write permissions levels that a user has for permissioned features. Key must be PermissionedFeatureOrObject"""
    grant: NotRequired[Dict[str, List[GrantPermissionTypedDict]]]
    r"""Describes the grant permission levels that a user has for permissioned features. Key must be PermissionedFeatureOrObject"""
    role: NotRequired[str]
    r"""The roleId of the canonical role a user has. The displayName is equal to the roleId."""
    roles: NotRequired[List[str]]
    r"""The roleIds of the roles a user has."""


class Permissions(BaseModel):
    r"""Describes the permissions levels that a user has for permissioned features. When the client sends this, Permissions.read and Permissions.write are the additional permissions granted to a user on top of what they have via their roles.
    When the server sends this, Permissions.read and Permissions.write are the complete (merged) set of permissions the user has, and Permissions.roles is just for display purposes.
    """

    can_admin_search: Annotated[
        Optional[bool], pydantic.Field(alias="canAdminSearch")
    ] = None
    r"""TODO--deprecate in favor of the read and write properties. True if the user has access to /adminsearch"""

    can_admin_client_api_global_tokens: Annotated[
        Optional[bool], pydantic.Field(alias="canAdminClientApiGlobalTokens")
    ] = None
    r"""TODO--deprecate in favor of the read and write properties. True if the user can administrate client API tokens with global scope"""

    can_dlp: Annotated[Optional[bool], pydantic.Field(alias="canDlp")] = None
    r"""TODO--deprecate in favor of the read and write properties. True if the user has access to data loss prevention (DLP) features"""

    read: Optional[Dict[str, List[ReadPermission]]] = None
    r"""Describes the read permission levels that a user has for permissioned features. Key must be PermissionedFeatureOrObject"""

    write: Optional[Dict[str, List[WritePermission]]] = None
    r"""Describes the write permissions levels that a user has for permissioned features. Key must be PermissionedFeatureOrObject"""

    grant: Optional[Dict[str, List[GrantPermission]]] = None
    r"""Describes the grant permission levels that a user has for permissioned features. Key must be PermissionedFeatureOrObject"""

    role: Optional[str] = None
    r"""The roleId of the canonical role a user has. The displayName is equal to the roleId."""

    roles: Optional[List[str]] = None
    r"""The roleIds of the roles a user has."""
