"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .userrolespecification import UserRoleSpecification, UserRoleSpecificationTypedDict
from glean.api_client.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ShortcutMutablePropertiesTypedDict(TypedDict):
    input_alias: NotRequired[str]
    r"""Link text following go/ prefix as entered by the user."""
    destination_url: NotRequired[str]
    r"""Destination URL for the shortcut."""
    destination_document_id: NotRequired[str]
    r"""Glean Document ID for the URL, if known."""
    description: NotRequired[str]
    r"""A short, plain text blurb to help people understand the intent of the shortcut."""
    unlisted: NotRequired[bool]
    r"""Whether this shortcut is unlisted or not. Unlisted shortcuts are visible to author + admins only."""
    url_template: NotRequired[str]
    r"""For variable shortcuts, contains the URL template; note, `destinationUrl` contains default URL."""
    added_roles: NotRequired[List[UserRoleSpecificationTypedDict]]
    r"""A list of user roles added for the Shortcut."""
    removed_roles: NotRequired[List[UserRoleSpecificationTypedDict]]
    r"""A list of user roles removed for the Shortcut."""


class ShortcutMutableProperties(BaseModel):
    input_alias: Annotated[Optional[str], pydantic.Field(alias="inputAlias")] = None
    r"""Link text following go/ prefix as entered by the user."""

    destination_url: Annotated[
        Optional[str], pydantic.Field(alias="destinationUrl")
    ] = None
    r"""Destination URL for the shortcut."""

    destination_document_id: Annotated[
        Optional[str], pydantic.Field(alias="destinationDocumentId")
    ] = None
    r"""Glean Document ID for the URL, if known."""

    description: Optional[str] = None
    r"""A short, plain text blurb to help people understand the intent of the shortcut."""

    unlisted: Optional[bool] = None
    r"""Whether this shortcut is unlisted or not. Unlisted shortcuts are visible to author + admins only."""

    url_template: Annotated[Optional[str], pydantic.Field(alias="urlTemplate")] = None
    r"""For variable shortcuts, contains the URL template; note, `destinationUrl` contains default URL."""

    added_roles: Annotated[
        Optional[List[UserRoleSpecification]], pydantic.Field(alias="addedRoles")
    ] = None
    r"""A list of user roles added for the Shortcut."""

    removed_roles: Annotated[
        Optional[List[UserRoleSpecification]], pydantic.Field(alias="removedRoles")
    ] = None
    r"""A list of user roles removed for the Shortcut."""
