"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
from glean.api_client.types import BaseModel
import pydantic
from typing import Dict, List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ToolParameterType(str, Enum):
    r"""Parameter type (string, number, boolean, object, array)"""

    STRING = "string"
    NUMBER = "number"
    BOOLEAN = "boolean"
    OBJECT = "object"
    ARRAY = "array"


class ToolParameterTypedDict(TypedDict):
    type: NotRequired[ToolParameterType]
    r"""Parameter type (string, number, boolean, object, array)"""
    name: NotRequired[str]
    r"""The name of the parameter"""
    description: NotRequired[str]
    r"""The description of the parameter"""
    is_required: NotRequired[bool]
    r"""Whether the parameter is required"""
    possible_values: NotRequired[List[str]]
    r"""The possible values for the parameter. Can contain only primitive values or arrays of primitive values."""
    items: NotRequired[ToolParameterTypedDict]
    properties: NotRequired[Dict[str, ToolParameterTypedDict]]
    r"""When type is 'object', this describes the structure of the object."""


class ToolParameter(BaseModel):
    type: Optional[ToolParameterType] = None
    r"""Parameter type (string, number, boolean, object, array)"""

    name: Optional[str] = None
    r"""The name of the parameter"""

    description: Optional[str] = None
    r"""The description of the parameter"""

    is_required: Annotated[Optional[bool], pydantic.Field(alias="isRequired")] = None
    r"""Whether the parameter is required"""

    possible_values: Annotated[
        Optional[List[str]], pydantic.Field(alias="possibleValues")
    ] = None
    r"""The possible values for the parameter. Can contain only primitive values or arrays of primitive values."""

    items: Optional[ToolParameter] = None

    properties: Optional[Dict[str, ToolParameter]] = None
    r"""When type is 'object', this describes the structure of the object."""
