"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .facetfilter import FacetFilter, FacetFilterTypedDict
from .structuredtext import StructuredText, StructuredTextTypedDict
from .thumbnail import Thumbnail, ThumbnailTypedDict
from datetime import datetime
from enum import Enum
from glean.api_client.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UpdateAnnouncementRequestChannel(str, Enum):
    r"""This determines whether this is a Social Feed post or a regular announcement."""

    MAIN = "MAIN"
    SOCIAL_FEED = "SOCIAL_FEED"


class UpdateAnnouncementRequestPostType(str, Enum):
    r"""This determines whether this is an external-link post or a regular announcement post. TEXT - Regular announcement that can contain rich text. LINK - Announcement that is linked to an external site."""

    TEXT = "TEXT"
    LINK = "LINK"


class UpdateAnnouncementRequestTypedDict(TypedDict):
    start_time: datetime
    r"""The date and time at which the announcement becomes active."""
    end_time: datetime
    r"""The date and time at which the announcement expires."""
    title: str
    r"""The headline of the announcement."""
    id: int
    r"""The opaque id of the announcement."""
    body: NotRequired[StructuredTextTypedDict]
    emoji: NotRequired[str]
    r"""An emoji used to indicate the nature of the announcement."""
    thumbnail: NotRequired[ThumbnailTypedDict]
    banner: NotRequired[ThumbnailTypedDict]
    audience_filters: NotRequired[List[FacetFilterTypedDict]]
    r"""Filters which restrict who should see the announcement. Values are taken from the corresponding filters in people search."""
    source_document_id: NotRequired[str]
    r"""The Glean Document ID of the source document this Announcement was created from (e.g. Slack thread)."""
    hide_attribution: NotRequired[bool]
    r"""Whether or not to hide an author attribution."""
    channel: NotRequired[UpdateAnnouncementRequestChannel]
    r"""This determines whether this is a Social Feed post or a regular announcement."""
    post_type: NotRequired[UpdateAnnouncementRequestPostType]
    r"""This determines whether this is an external-link post or a regular announcement post. TEXT - Regular announcement that can contain rich text. LINK - Announcement that is linked to an external site."""
    is_prioritized: NotRequired[bool]
    r"""Used by the Social Feed to pin posts to the front of the feed."""
    view_url: NotRequired[str]
    r"""URL for viewing the announcement. It will be set to document URL for announcements from other datasources e.g. simpplr. Can only be written when channel=\"SOCIAL_FEED\"."""


class UpdateAnnouncementRequest(BaseModel):
    start_time: Annotated[datetime, pydantic.Field(alias="startTime")]
    r"""The date and time at which the announcement becomes active."""

    end_time: Annotated[datetime, pydantic.Field(alias="endTime")]
    r"""The date and time at which the announcement expires."""

    title: str
    r"""The headline of the announcement."""

    id: int
    r"""The opaque id of the announcement."""

    body: Optional[StructuredText] = None

    emoji: Optional[str] = None
    r"""An emoji used to indicate the nature of the announcement."""

    thumbnail: Optional[Thumbnail] = None

    banner: Optional[Thumbnail] = None

    audience_filters: Annotated[
        Optional[List[FacetFilter]], pydantic.Field(alias="audienceFilters")
    ] = None
    r"""Filters which restrict who should see the announcement. Values are taken from the corresponding filters in people search."""

    source_document_id: Annotated[
        Optional[str], pydantic.Field(alias="sourceDocumentId")
    ] = None
    r"""The Glean Document ID of the source document this Announcement was created from (e.g. Slack thread)."""

    hide_attribution: Annotated[
        Optional[bool], pydantic.Field(alias="hideAttribution")
    ] = None
    r"""Whether or not to hide an author attribution."""

    channel: Optional[UpdateAnnouncementRequestChannel] = None
    r"""This determines whether this is a Social Feed post or a regular announcement."""

    post_type: Annotated[
        Optional[UpdateAnnouncementRequestPostType], pydantic.Field(alias="postType")
    ] = None
    r"""This determines whether this is an external-link post or a regular announcement post. TEXT - Regular announcement that can contain rich text. LINK - Announcement that is linked to an external site."""

    is_prioritized: Annotated[Optional[bool], pydantic.Field(alias="isPrioritized")] = (
        None
    )
    r"""Used by the Social Feed to pin posts to the front of the feed."""

    view_url: Annotated[Optional[str], pydantic.Field(alias="viewUrl")] = None
    r"""URL for viewing the announcement. It will be set to document URL for announcements from other datasources e.g. simpplr. Can only be written when channel=\"SOCIAL_FEED\"."""
