"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .documentpermissionsdefinition import (
    DocumentPermissionsDefinition,
    DocumentPermissionsDefinitionTypedDict,
)
from glean.api_client.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UpdatePermissionsRequestTypedDict(TypedDict):
    r"""Describes the request body of the /updatepermissions API call"""

    datasource: str
    permissions: DocumentPermissionsDefinitionTypedDict
    r"""describes the access control details of the document"""
    object_type: NotRequired[str]
    r"""The type of the document (Case, KnowledgeArticle for Salesforce for example). It cannot have spaces or _"""
    id: NotRequired[str]
    r"""The datasource specific id for the document. This field is case insensitive and should not be more than 200 characters in length."""
    view_url: NotRequired[str]
    r"""The permalink for viewing the document. **Note: viewURL is a required field if id was not set when uploading the document.**'

    """


class UpdatePermissionsRequest(BaseModel):
    r"""Describes the request body of the /updatepermissions API call"""

    datasource: str

    permissions: DocumentPermissionsDefinition
    r"""describes the access control details of the document"""

    object_type: Annotated[Optional[str], pydantic.Field(alias="objectType")] = None
    r"""The type of the document (Case, KnowledgeArticle for Salesforce for example). It cannot have spaces or _"""

    id: Optional[str] = None
    r"""The datasource specific id for the document. This field is case insensitive and should not be more than 200 characters in length."""

    view_url: Annotated[Optional[str], pydantic.Field(alias="viewURL")] = None
    r"""The permalink for viewing the document. **Note: viewURL is a required field if id was not set when uploading the document.**'

    """
